Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadToolTipControllerClass=function(){
this._tooltipToShow=null;
this._activeToolTip=null;
this._registerGlobalBodyEventHandlers();
};
Telerik.Web.UI.RadToolTipControllerClass.prototype={_registerGlobalBodyEventHandlers:function(){
var _1=Function.createDelegate(this,function(e){
if(e.keyCode==27){
if(this._activeToolTip&&!this._activeToolTip.isModal()){
this._hideCurrentToolTipUnconditionally();
}
}
});
$addHandler(document.body,"keydown",_1);
var _3=Function.createDelegate(this,function(e){
this._hideOnBodyClick(e);
});
$addHandler(document.body,"click",_3);
Sys.Application.add_unload(function(){
$removeHandler(document.body,"keydown",_1);
$removeHandler(document.body,"click",_3);
});
},_hideOnBodyClick:function(e){
var _6=true;
if(this._activeToolTip!=null){
var _7=this._activeToolTip;
if(_7._isMouseOverElement(e,_7._tableElement)){
return;
}
_6=this._activeToolTip.hide(true);
}
if(_6){
this._activeToolTip=null;
}
},_cancelLastShowRequest:function(){
if(this._tooltipToShow){
var _8=this._tooltipToShow;
this._tooltipToShow=null;
_8.cancelShowDelay();
}
},_hideCurrentToolTipUnconditionally:function(){
this._cancelLastShowRequest();
if(this._activeToolTip!=null){
this._activeToolTip.hide();
}
this._activeToolTip=null;
},requestShow:function(_9){
this._cancelLastShowRequest();
this._tooltipToShow=_9;
},cancelSpecificShowRequest:function(_a){
if(this._tooltipToShow==_a){
this._cancelLastShowRequest();
}
},showTooltip:function(_b){
if(!_b||_b.isVisible()){
return;
}
this._cancelLastShowRequest();
this.set_activeToolTip(_b);
_b.show();
},notifyToolTipClosed:function(_c){
if(this._activeToolTip==_c){
this._activeToolTip=null;
}
},set_activeToolTip:function(_d){
if(_d!=this._activeToolTip){
this._hideCurrentToolTipUnconditionally();
}
this._activeToolTip=_d;
},get_activeToolTip:function(){
return this._activeToolTip;
},getInstance:function(){
return this;
}};
Telerik.Web.UI.RadToolTipControllerClass.registerClass("Telerik.Web.UI.RadToolTipControllerClass",null);
if(!Telerik.Web.UI.RadToolTipController){
Telerik.Web.UI.RadToolTipController=new Telerik.Web.UI.RadToolTipControllerClass();
}
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadToolTip=function(_e){
Telerik.Web.UI.RadToolTip.initializeBase(this,[_e]);
this._offsetX=0;
this._offsetY=6;
this._position=Telerik.Web.UI.ToolTipPosition.BottomCenter;
this._horizontalPosition=null;
this._verticalPosition=null;
this._targetControlID=null;
this._serverTargetControlID=null;
this._serverValue="";
this._formID=null;
this._targetControl=null;
this._popupElement=null;
this._tableElement=null;
this._contentCell=null;
this._titleElement=null;
this._contentElement=null;
this._calloutElement=null;
this._closeLink=null;
this._popupBehavior=null;
this._popupVisible=false;
this._modal=false;
this._onModalShowHandler=null;
this._onModalCloseHandler=null;
this._skin="Default";
this._title="";
this._text="";
this._width="";
this._height="";
this._relativeTo=Telerik.Web.UI.ToolTipRelativeDisplay.Mouse;
this._contentScrolling=Telerik.Web.UI.ToolTipScrolling.Auto;
this._showEvent=Telerik.Web.UI.ToolTipShowEvent.OnMouseOver;
this._visibleOnPageLoad=false;
this._sticky=false;
this._manualClose=false;
this._mouseTrailing=false;
this._showCallout=true;
this._showDelayRef=null;
this._autoCloseRef=null;
this._showDelay=300;
this._autoCloseDelay=2000;
this._hideDelay=100;
this._animation=Telerik.Web.UI.ToolTipAnimation.None;
this._tooltipAnimation=null;
this._zIndex=8000;
};
Telerik.Web.UI.RadToolTip.getCurrent=function(){
var _f=Telerik.Web.UI.RadToolTipController.getInstance();
if(!_f){
return null;
}
return _f.get_activeToolTip();
};
Telerik.Web.UI.RadToolTip.prototype={get_zIndex:function(){
return this._zIndex;
},set_zIndex:function(_10){
var _11=parseInt(_10);
if(isNaN(_10)){
return;
}
if(this._zIndex!=_10){
this._zIndex=_10;
}
},initialize:function(){
Telerik.Web.UI.RadToolTip.callBaseMethod(this,"initialize");
this.set_position(this._position);
if(this._visibleOnPageLoad){
this.show();
}
},dispose:function(){
if(this._tooltipAnimation){
this._tooltipAnimation.dispose();
}
if(this._popupBehavior){
this._popupBehavior.dispose();
this._popupBehavior=null;
}
this._registerPopupHandlers(false);
this._registerMouseHandlers(this._targetControl,false);
this._makeModal(false);
if(this._closeLinkHandler&&this._closeLink){
$removeHandler(this._closeLink,"click",this._closeLinkHandler);
this._closeLinkHandler=null;
}
if(this._popupElement){
var _12=this.get_id();
if(_12){
var _13=$get(_12);
if(_13){
_13.appendChild(this._popupElement);
}
}
}
Telerik.Web.UI.RadToolTip.callBaseMethod(this,"dispose");
},isCreated:function(){
return this._popupElement!=null;
},requestShow:function(){
this._resetShowDelay();
},hide:function(_14){
if(true==_14&&this._manualClose){
return false;
}
this._hide();
return true;
},clone:function(_15,_16){
if(!_15){
alert("clone error: No target element specified");
return;
}
var evs=this._getEventsParameter();
var _18=this._getPropertiesParameter();
_18["targetControlID"]=_15.getAttribute("id");
if(!_18["targetControlID"]){
_18["targetControl"]=_15;
}
var _19=document.createElement("SPAN");
if(_16){
_19.setAttribute("id",_16);
}
var _1a=$create(Telerik.Web.UI.RadToolTip,_18,evs,null,_19);
return _1a;
},show:function(){
this._createUI();
var _1b=new Sys.CancelEventArgs();
this.raiseEvent("beforeShow",_1b);
if(_1b.get_cancel()){
return;
}
if($telerik.isIE6){
var _1c=this;
window.setTimeout(function(){
_1c._registerPopupHandlers(true);
},200);
}else{
this._registerPopupHandlers(true);
}
this._getToolTipController().set_activeToolTip(this);
this._popupBehavior.pin(false);
window.setTimeout(Function.createDelegate(this,function(){
if(this._animation==Telerik.Web.UI.ToolTipAnimation.None){
this._show();
this._afterShow();
}else{
this._playAnimation();
}
}),0);
},showLoadingMessage:function(_1d){
if(_1d){
var div=document.createElement("DIV");
div.className=this._getFullSkinName()+" LoadingSign";
this._contentCell.appendChild(div);
}else{
this._contentCell.innerHTML="";
}
},isModal:function(){
return this._modal;
},set_contentElement:function(_1f){
this._contentCell.innerHTML="";
if(_1f.parentNode&&_1f.parentNode.removeChild){
_1f.parentNode.removeChild(_1f);
}
this._contentCell.appendChild(_1f);
_1f.style.display="";
this._contentElement=_1f;
},get_contentElement:function(){
return this._contentElement;
},set_content:function(_20){
var _21=document.createElement("DIV");
_21.innerHTML=_20;
this._text=_20;
if(this.isCreated()){
this.set_contentElement(_21);
}
},get_content:function(){
return this._contentElement?this._contentElement.innerHTML:"";
},cancelAutoCloseDelay:function(){
if(this._autoCloseRef){
window.clearTimeout(this._autoCloseRef);
this._autoCloseRef=0;
}
},cancelShowDelay:function(){
if(this._showDelayRef){
window.clearTimeout(this._showDelayRef);
this._showDelayRef=null;
}
this._getToolTipController().cancelSpecificShowRequest(this);
},_getToolTipController:function(){
return Telerik.Web.UI.RadToolTipController.getInstance();
},_resetAutoCloseDelay:function(){
this.cancelAutoCloseDelay();
if(this._manualClose||this._sticky){
return;
}
if(this._autoCloseDelay){
var _22=this;
this._autoCloseRef=window.setTimeout(function(){
_22.hide(true);
},this._autoCloseDelay);
}
},_resetShowDelay:function(){
this.cancelShowDelay();
var _23=this;
var _24=function(){
_23._getToolTipController().showTooltip(_23);
_23.cancelShowDelay();
};
this._showDelayRef=window.setTimeout(_24,this._showDelay);
},_show:function(){
var _25=null;
try{
_25=this.getToolTipBounds();
}
catch(e){
var _26=this;
window.setTimeout(function(){
_26._addToolTipToDocument();
},10);
return;
}
this._setPopupVisible(_25.x,_25.y);
this._resetAutoCloseDelay();
this._popupVisible=true;
},_afterShow:function(){
this._popupBehavior.pin(this._isRelativeToBrowserWindow());
this.raiseEvent("show");
},_hide:function(){
if(this._tooltipAnimation){
this._tooltipAnimation.stop();
}
this.cancelShowDelay();
this.cancelAutoCloseDelay();
var _27=new Sys.CancelEventArgs();
this.raiseEvent("beforeHide",_27);
if(_27.get_cancel()){
return;
}
if(this._tooltipAnimation){
this._tooltipAnimation.play(true);
}else{
this._afterHide();
}
},_afterHide:function(){
try{
if(this._popupBehavior){
this._popupBehavior.hide(true);
this._popupBehavior.pin(false);
}
}
catch(ex){
}
this._popupVisible=false;
this._getToolTipController().notifyToolTipClosed(this);
this.raiseEvent("hide");
this._registerPopupHandlers(false);
},_isRelativeToBrowserWindow:function(){
if(!this._targetControl||this._relativeTo==Telerik.Web.UI.ToolTipRelativeDisplay.BrowserWindow){
return true;
}
return false;
},_playAnimation:function(){
var _28=function(){
var _29=this.controller;
var _2a=_29.getToolTipBounds();
_29._setPopupVisible(_2a.x,_2a.y);
var _2b=$telerik.getBounds(_29._popupElement);
_29._popupBehavior.hide();
this.set_endBounds(_2b);
};
if(!this._tooltipAnimation){
var pos=this._position;
var vp=this._verticalPosition;
var _2e=this._isRelativeToBrowserWindow();
if(_2e&&this._verticalPosition!=2){
vp=(this._verticalPosition==1?3:1);
pos=parseInt(vp+""+this._horizontalPosition);
}
var _2f=_2e?document.documentElement:this._targetControl;
if(this._animation==Telerik.Web.UI.ToolTipAnimation.Fade){
this._tooltipAnimation=new Telerik.Web.UI.Animations.FadeAnimation(this,null,null,this._popupElement,this._position,_2f);
this._tooltipAnimation.onShowStart=function(){
this.controller._show();
};
}else{
if(this._animation==Telerik.Web.UI.ToolTipAnimation.FlyIn){
this._tooltipAnimation=new Telerik.Web.UI.Animations.FlyInAnimation(this,null,null,this._popupElement,this._position,_2f);
this._tooltipAnimation.onShowStart=_28;
}else{
if(this._animation==Telerik.Web.UI.ToolTipAnimation.Slide){
this._tooltipAnimation=new Telerik.Web.UI.Animations.SlideAnimation(this,null,null,this._popupElement,pos,_2f);
this._tooltipAnimation.onShowStart=_28;
}else{
if(this._animation==Telerik.Web.UI.ToolTipAnimation.Resize){
if(_2e&&this._horizontalPosition!=2){
var hp=(this._horizontalPosition==1?3:1);
pos=parseInt(vp+""+hp);
}
this._tooltipAnimation=new Telerik.Web.UI.Animations.ResizeAnimation(this,0.2,50,this._popupElement,pos,_2f);
this._tooltipAnimation.onShowStart=_28;
}
}
}
}
}
if(this._tooltipAnimation){
if(this._isRelativeToBrowserWindow()){
this._documentOverflowX=document.documentElement.style.overflowX;
document.documentElement.style.overflowX="hidden";
}
this._tooltipAnimation.onShowEnd=function(){
this.controller._show();
if(null!=this.controller._documentOverflowX){
document.documentElement.style.overflowX=this.controller._documentOverflowX;
this.controller._documentOverflowX=null;
}
this.controller._afterShow();
};
this._tooltipAnimation.onHideEnd=function(){
this.controller._afterHide();
};
this._tooltipAnimation.play();
}
},_makeModal:function(_31){
if(this._onModalShowHandler){
this.remove_show(this._onModalShowHandler);
this._onModalShowHandler=null;
}
if(this._onModalCloseHandler){
this.remove_hide(this._onModalCloseHandler);
this._onModalCloseHandler=null;
}
if(this._modalExtender){
this._modalExtender.dispose();
this._modalExtender=null;
}
if(!_31){
return;
}
this._onModalShowHandler=function(_32){
if(!_32._modalExtender){
_32._modalExtender=new Telerik.Web.UI.ModalExtender(_32._popupElement);
}
_32._modalExtender.show();
};
this.add_show(this._onModalShowHandler);
this._onModalCloseHandler=function(_33){
if(_33._modalExtender){
_33._modalExtender.hide();
}
};
this.add_hide(this._onModalCloseHandler);
},_isMouseOverElement:function(e,_35){
var _36=null;
try{
_36=$telerik.getBounds(_35);
}
catch(e){
return false;
}
if(e&&e.target){
var _37=e.target.tagName;
if(_37=="SELECT"||_37=="OPTION"){
return true;
}
if(e.clientX<0||e.clientY<0){
return true;
}
}
var _38=(document.compatMode&&document.compatMode!="BackCompat")?document.documentElement:document.body;
var x=e.clientX+_38.scrollLeft;
var y=e.clientY+_38.scrollTop;
_36.x+=3;
_36.y+=2;
_36.width-=4;
_36.height-=4;
var _3b=$telerik.containsPoint(_36,x,y);
return _3b;
},_onMouseOver:function(e){
this._logMousePosition(e);
this._resetShowDelay();
this._getToolTipController().requestShow(this);
if(e){
}
},_onMouseMove:function(e){
this._logMousePosition(e);
this._resetAutoCloseDelay();
if(this._mouseTrailing&&this.isVisible()){
this._show();
}
},_onMouseOut:function(e){
var _3f=this._isMouseOverElement(e,this._targetControl);
if(!_3f){
this.cancelShowDelay();
if(!this._sticky){
if(this._hideDelay>0){
var _40=this;
window.setTimeout(function(){
_40.hide(true);
},this._hideDelay);
}else{
this.hide(true);
}
}
}
},_onClick:function(e){
this._onMouseOver(e);
e.returnValue=false;
e.cancelBubble=true;
return false;
},_onRightClick:function(e){
this._onMouseOver(e);
e.returnValue=false;
e.cancelBubble=true;
return false;
},_registerMouseHandlers:function(_43,_44){
if(true==_44){
var _45={};
var _46=Telerik.Web.UI.ToolTipShowEvent;
if(this._showEvent==_46.OnMouseOver){
this._onMouseOverDelegate=Function.createDelegate(this,this._onMouseOver);
this._onMouseMoveDelegate=Function.createDelegate(this,this._onMouseMove);
this._onMouseOutDelegate=Function.createDelegate(this,this._onMouseOut);
$addHandler(_43,"mouseover",this._onMouseOverDelegate);
$addHandler(_43,"mousemove",this._onMouseMoveDelegate);
$addHandler(_43,"mouseout",this._onMouseOutDelegate);
}
if(this._showEvent==_46.OnClick){
this._onClickDelegate=Function.createDelegate(this,this._onClick);
$addHandler(_43,"click",this._onClickDelegate);
}
if(this._showEvent==_46.OnRightClick){
this._onRightClickDelegate=Function.createDelegate(this,this._onRightClick);
$addHandler(_43,"contextmenu",this._onRightClickDelegate);
}
if(this._showEvent==_46.OnFocus){
this._onFocusDelegate=Function.createDelegate(this,this._onMouseOver);
this._onBlurDelegate=Function.createDelegate(this,this._onMouseOut);
$addHandler(_43,"focus",this._onFocusDelegate);
$addHandler(_43,"blur",this._onBlurDelegate);
}
}else{
if(_43){
var _47=[["mouseover",this._onMouseOverDelegate],["mousemove",this._onMouseMoveDelegate],["mouseout",this._onMouseOutDelegate],["click",this._onClickDelegate],["contextmenu",this._onRightClickDelegate],["focus",this._onFocusDelegate],["blur",this._onBlurDelegate]];
for(var i=0;i<_47.length;i++){
var _49=_47[i];
try{
if(null!=_49[1]){
$removeHandler(_43,_49[0],_49[1]);
}
}
catch(e){
}
}
this._onMouseOverDelegate=null;
this._onMouseMoveDelegate=null;
this._onMouseOutDelegate=null;
this._onClickDelegate=null;
this._onRightClickDelegate=null;
this._onFocusDelegate=null;
this._onBlurDelegate=null;
}
}
},_registerPopupHandlers:function(_4a){
if(true==_4a){
if(this._sticky||this._position==Telerik.Web.UI.ToolTipPosition.Center){
this._popupStickyHandler=Function.createDelegate(this,this._onPopupStickyMouseOut);
$addHandler(this._tableElement,"mouseout",this._popupStickyHandler);
this.set_sticky(true);
}
}else{
if(this._popupStickyHandler){
$removeHandler(this._tableElement,"mouseout",this._popupStickyHandler);
this._popupStickyHandler=null;
}
}
},_onPopupStickyMouseOut:function(e){
var _4c=this._isMouseOverElement(e,this._tableElement);
if(!_4c&&!this._manualClose){
this.hide();
}
},_getPropertiesParameter:function(){
if(!this._propertiesParameter){
var _4d={};
for(var _4e in Telerik.Web.UI.RadToolTip.prototype){
var _4f=this[_4e];
if(typeof (_4f)=="function"&&_4e.indexOf("get_")==0){
var _50=_4e.substring(4);
if(null==this["set_"+_50]){
continue;
}
var _51=_4f.call(this);
if(null==_51){
continue;
}
_4d[_50]=_51;
if(_50=="skin"){
break;
}
}
}
this._propertiesParameter=_4d;
}
var _52=this._cloneObject(this._propertiesParameter);
return _52;
},_getEventsParameter:function(){
if(!this._eventsParameter){
var _53={};
var _54=this.get_events();
var _55=["beforeShow","show","beforeHide","hide"];
for(var i=0;i<_55.length;i++){
var _57=_55[i];
var _58=_54.getHandler(_57);
if(_58&&typeof (eval(_58))=="function"){
_53[_57]=eval(_58);
}
}
this._eventsParameter=_53;
}
return this._eventsParameter;
},_cloneObject:function(_59){
var _5a={};
for(var _5b in _59){
_5a[_5b]=_59[_5b];
}
return _5a;
},_getPosRelativeToMouse:function(_5c){
var _5d=_5c.x;
var _5e=_5c.y;
var pos=this._getMousePosition();
var _60=pos.clientX;
var _61=pos.clientY;
if($telerik.standardsMode){
_5d-=document.documentElement.scrollLeft;
_5e-=document.documentElement.scrollTop;
}
var _62=_60-_5d;
var _63=_61-_5e;
return {x:_62,y:_63};
},_logMousePosition:function(e){
if(!e){
return;
}
this._mouseX=e.clientX;
this._mouseY=e.clientY;
},_getMousePosition:function(){
var obj={};
obj.clientX=this._mouseX;
obj.clientY=this._mouseY;
return obj;
},_getCalloutBounds:function(){
var _66={width:0,height:0,marginLeft:0,marginTop:0};
if(this._showCallout&&this._calloutElement){
_66.marginLeft=parseInt($telerik.getCurrentStyle(this._calloutElement,"marginLeft"));
_66.marginTop=parseInt($telerik.getCurrentStyle(this._calloutElement,"marginTop"));
if(isNaN(_66.marginLeft)){
_66.marginLeft=0;
}
if(isNaN(_66.marginLeft)){
_66.marginLeft=0;
}
var _67=$telerik.getBounds(this._calloutElement);
if(_67){
if(_67.width){
_66.width=_67.width;
}
if(_67.height){
_66.height=_67.height;
}
}
}
return _66;
},_getBoundsRelativeToBrowser:function(_68,_69,_6a){
var _6b=this._horizontalPosition;
var _6c=this._verticalPosition;
var x=0;
var y=0;
if(!_6a){
_6a=$telerik.getClientBounds();
}
var _6f=$telerik.getScrollOffset(document.compatMode&&document.compatMode!="BackCompat"?document.documentElement:document.body);
if("fixed"!=this._popupElement.style.position){
x+=_6f.x;
y+=_6f.y;
}
switch(_6b){
case 2:
x+=-parseInt(_68.width/2-_6a.width/2);
x+=this._offsetX;
break;
case 3:
x+=_6a.width;
x-=_68.width;
x-=this._offsetX;
break;
case 1:
default:
x+=-_68.width;
x+=(-_69.width-_69.marginLeft);
x+=this._offsetX;
break;
}
switch(_6c){
case 2:
y+=-parseInt((_68.height-_6a.height)/2);
break;
case 1:
y+=this._offsetY;
break;
case 3:
default:
y+=_6a.height;
y-=this._offsetY;
y-=_68.height;
break;
}
return new Sys.UI.Bounds(x,y,_68.width,_68.height);
},_getBoundsRelativeToElement:function(_70,_71,_72){
var _73=this._horizontalPosition;
var _74=this._verticalPosition;
var x=0;
var y=0;
if(!_72){
_72=$telerik.getBounds(this._targetControl);
}
switch(_73){
case 2:
x+=-parseInt(_70.width/2-_72.width/2);
x+=this._offsetX;
break;
case 3:
x+=_72.width;
x-=_71.marginLeft;
x+=this._offsetX;
break;
case 1:
default:
x+=-_70.width;
x+=(-_71.width-_71.marginLeft);
x-=this._offsetX;
break;
}
switch(_74){
case 2:
y+=-parseInt(_70.height/2-_72.height/2);
y+=this._offsetY;
break;
case 1:
y-=_70.height;
y-=_71.height+_71.marginTop;
y-=this._offsetY;
break;
case 3:
default:
y+=_72.height;
y-=_71.marginTop;
y+=this._offsetY;
break;
}
return new Sys.UI.Bounds(x,y,_70.width,_70.height);
},_getBoundsRelativeToMouse:function(_77,_78,_79){
var _79=this._targetControl?$telerik.getBounds(this._targetControl):$telerik.getClientBounds();
var pos=this._getPosRelativeToMouse(_79);
if(isNaN(pos.x)){
pos.x=0;
pos.y=0;
}else{
_79.width=0;
_79.height=0;
}
var _7b=this._getBoundsRelativeToElement(_77,_78,_79);
var _7c=new Sys.UI.Bounds(pos.x+_7b.x,pos.y+_7b.y,_77.width,_77.height);
return _7c;
},getToolTipBounds:function(){
var _7d=this._popupElement;
var _7e=(_7d.style.display=="none")?true:false;
_7d.style.left="-3000px";
_7d.style.top="-3000px";
_7d.style.display="";
this._setOverflow();
if(this._firstShow!=true){
this._fixIeHeight(this._tableElement,this._height);
this._firstShow=true;
}
var _7f=this._isRelativeToBrowserWindow()?document.documentElement:this._targetControl;
this._popupBehavior.set_parentElement(_7f);
var _80=$telerik.getBounds(_7d);
var _81=this._getCalloutBounds();
if(_7e){
this._popupElement.style.display="none";
}
var _82=Telerik.Web.UI.ToolTipRelativeDisplay;
var _83=Telerik.Web.UI.ToolTipShowEvent;
var _84=null;
if(this._relativeTo==_82.BrowserWindow){
_84=this._getBoundsRelativeToBrowser(_80,_81);
}else{
if(!this._targetControl&&this._showEvent==_83.FromCode){
_84=this._getBoundsRelativeToBrowser(_80,_81);
}else{
if(this._targetControl&&this._showEvent==_83.FromCode){
_84=this._getBoundsRelativeToElement(_80,_81);
}else{
if((this._mouseTrailing||this._relativeTo==_82.Mouse)){
_84=this._getBoundsRelativeToMouse(_80,_81);
}else{
if(this._relativeTo==_82.Element){
_84=this._getBoundsRelativeToElement(_80,_81);
}
}
}
}
}
return _84;
},_fixIeHeight:function(_85,_86){
if("CSS1Compat"==document.compatMode){
var _87=(_85.offsetHeight-parseInt(_86));
if(_87>0){
var _88=(parseInt(_85.style.height)-_87);
if(_88>0){
_85.style.height=_88+"px";
}
}
}
},_refreshTitle:function(){
if(null==this._titleElement){
return;
}
this._titleElement.innerHTML=this._title;
this._titleElement.style.display=(this._title)?"":"none";
},_createUI:function(){
if(!this._popupElement){
var _89=this.get_id();
var _8a="RadToolTipWrapper_"+_89;
var _8b=document.createElement("DIV");
_8b.id=_8a;
_8b.className=this._getFullSkinName()+(this.get_showCallout()?" visiblecallout":"");
_8b.setAttribute("unselectable","on");
this._popupElement=_8b;
var _8c=document.createElement("DIV");
_8c.className="ToolTipCallout "+this._getCalloutPosition(this._position);
_8c.innerHTML="&nbsp;";
this._calloutElement=_8c;
var _8d=document.createElement("TABLE");
_8d.className="ToolTipWrapper";
_8d.style.width=this._width;
_8d.style.height=this._height;
this._tableElement=_8d;
var _8e=["ToolTipTopLeft","ToolTipTopCenter","ToolTipTopRight","ToolTipLeftMiddle","ToolTipContent","ToolTipRightMiddle","ToolTipBottomLeft","ToolTipBottomCenter","ToolTipBottomRight"];
var _8f=0;
for(var i=1;i<=3;i++){
var _91=_8d.insertRow(-1);
for(var j=1;j<=3;j++){
var _93=_91.insertCell(-1);
_93.innerHTML="&nbsp;";
_93.className=_8e[_8f];
_8f++;
}
}
var _94=_8d.rows[0].cells[1];
_94.innerHTML="";
var _95=document.createElement("DIV");
_95.className="ToolTipTitlebar VisibleTitlebar";
_95.style.display="none";
this._titleElement=_95;
this._refreshTitle();
_94.appendChild(_95);
if(this._manualClose){
var _96=document.createElement("A");
_96.href="javascript: void(0);";
_96.className="CloseButton";
this._closeLinkHandler=Function.createDelegate(this,function(e){
this.hide();
if(e){
e.returnValue=false;
e.cancelBubble=true;
if(e.stopPropagation){
e.stopPropagation();
}
}
return false;
});
$addHandler(_96,"click",this._closeLinkHandler);
this._closeLink=_96;
var _98=document.createElement("SPAN");
_98.innerHTML="Close";
_96.title="Close";
_96.appendChild(_98);
_94.appendChild(_96);
}
var _99=_8d.rows[1].cells[1];
_99.vAlign="top";
_99.innerHTML="";
this._contentCell=_99;
var _9a=null;
var _9b=this._targetControl;
var _9c=this.get_text();
var _9a=null;
var _9d=this.get_text();
if(this._targetControl&&!_9d){
_9d=this._targetControl.getAttribute("title");
if(_9d){
this._targetControl.removeAttribute("title");
}
this._text=_9d;
}
if(this._text){
this.set_content(this._text);
}else{
var _9e=this.get_id();
if(_9e){
_9a=$get(_9e);
}
if(_9a&&_9a.innerHTML){
var _9f=this._transferNodeChildren(_9a);
this.set_contentElement(_9f);
}
}
_8b.appendChild(_8c);
_8b.appendChild(_8d);
this._popupElement.style.display="none";
this._popupElement.style.position="absolute";
this._addToolTipToDocument(_9a);
}
if(!this._popupBehavior){
this._popupBehavior=$create(Telerik.Web.PopupBehavior,{"id":(new Date()-100)+"PopupBehavior","parentElement":this._targetControl},null,null,this._popupElement);
}
},_transferNodeChildren:function(_a0){
if(!_a0){
return null;
}
var _a1=_a0.ownerDocument.createElement(_a0.tagName);
if(_a0.control){
_a1.control=_a0.control;
}
while(_a0.childNodes&&_a0.childNodes.length>0){
var _a2=_a0.childNodes[0];
_a0.removeChild(_a2);
_a1.appendChild(_a2);
}
return _a1;
},_addToolTipToDocument:function(_a3){
if(null!=_a3){
_a3.parentNode.replaceChild(this._popupElement,_a3);
return;
}
var _a4=document.getElementById(this._formID);
if(!_a4){
_a4=document.forms[0];
}
_a4.appendChild(this._popupElement);
},_getParentByTagName:function(_a5,_a6){
var _a7=_a5;
_a6=_a6.toUpperCase();
while(_a7.tagName.toUpperCase()!=_a6){
_a7=_a7.parentNode;
if(!_a7){
break;
}
}
return _a7;
},_getFullSkinName:function(){
return "radtooltip_"+this._skin;
},_getUniqueString:function(){
return ""+(new Date()-100);
},_getCalloutPosition:function(_a8){
with(Telerik.Web.UI.ToolTipPosition){
switch(_a8){
case TopLeft:
return "BottomRight";
case TopCenter:
return "BottomCenter";
case TopRight:
return "BottomLeft";
case MiddleLeft:
return "MiddleRight";
case Center:
return "Center";
case MiddleRight:
return "MiddleLeft";
case BottomLeft:
return "TopRight";
case BottomCenter:
return "TopCenter";
case BottomRight:
return "TopLeft";
}
}
return "";
},_getHorizontalSide:function(_a9){
return parseInt((_a9+"").charAt(1));
},_getVerticalSide:function(_aa){
return parseInt((_aa+"").charAt(0));
},_setPopupVisible:function(x,y){
this._popupBehavior.set_x(x);
this._popupBehavior.set_y(y);
this._popupBehavior.show();
if(!this.get_width()){
this._popupElement.style.width="";
}
this._popupElement.style.zIndex=this._zIndex;
},_setOverflow:function(){
var _ad=this._contentScrolling;
if(_ad==Telerik.Web.UI.ToolTipScrolling.Auto){
return;
}
var el=this._contentElement;
if(!el){
return;
}
var _af="";
with(Telerik.Web.UI.ToolTipScrolling){
switch(_ad){
case Auto:
_af="auto";
break;
case None:
_af="hidden";
break;
case X:
_af="";
el.style.overflowX="scroll";
break;
case Y:
_af="";
el.style.overflowY="scroll";
break;
case Both:
_af="scroll";
}
}
var _b0=el.parentNode;
el.style.display="none";
var _b1=$telerik.getBounds(_b0).height;
el.style.height=_b1+"px";
if(!el.style.overflowX&&!el.style.overflowY){
el.style.overflow=_af;
}
el.style.display="";
},_getLeftOffset:function(){
var _b2=Telerik.Web.UI.ToolTipPosition;
if(_b2.Left==this._position){
return (-1*this._targetControl.offsetWidth)+this._offsetX;
}else{
if(_b2.Right==this._position){
return this._targetControl.offsetWidth+this._offsetX;
}else{
return this._offsetX;
}
}
},_getTopOffset:function(){
var _b3;
var _b4=Telerik.Web.UI.ToolTipPosition;
if(_b4.Top==this._position){
_b3=(-1*this._targetControl.offsetHeight)+this._offsetY;
}else{
if(_b4.Bottom==this._position){
_b3=this._targetControl.offsetHeight+this._offsetY;
}else{
_b3=this._offsetY;
}
}
return _b3;
},isVisible:function(){
return this._popupVisible;
},get_targetControlID:function(){
return this._targetControlID;
},set_targetControlID:function(_b5){
if(this._targetControlID!=_b5){
this._targetControlID=_b5;
var _b6=(this._targetControlID?$get(this._targetControlID):null);
this.set_targetControl(_b6);
}
},get_targetControl:function(){
return this._targetControl;
},set_targetControl:function(_b7){
if(this._targetControl!=_b7){
if(this._targetControl&&(this._targetControl!=_b7)){
this._registerMouseHandlers(this._targetControl,false);
}
this._targetControl=_b7;
var _b8=this._targetControl;
if(_b8){
if($telerik.isIE&&_b8){
_b8.removeAttribute("alt");
}
this._registerMouseHandlers(_b8,true);
if(this._popupBehavior){
this._popupBehavior.set_parentElement(_b8);
}
}
}
},get_serverTargetControlID:function(){
return this._serverTargetControlID;
},set_serverTargetControlID:function(_b9){
this._serverTargetControlID=_b9;
},get_serverValue:function(){
return this._serverValue;
},set_serverValue:function(_ba){
this._serverValue=_ba;
},get_formID:function(){
return this._formID;
},set_formID:function(_bb){
if(this._formID!=_bb){
this._formID=_bb;
}
},get_position:function(){
return this._position;
},set_position:function(_bc){
if(this._position!=_bc){
this._position=_bc;
if(this._calloutElement){
this._calloutElement.className="ToolTipCallout "+this._getCalloutPosition(this._position);
}
}
this._horizontalPosition=this._getHorizontalSide(this._position);
this._verticalPosition=this._getVerticalSide(this._position);
},get_offsetX:function(){
return this._offsetX;
},set_offsetX:function(_bd){
if(this._offsetX!=_bd){
this._offsetX=_bd;
}
},get_offsetY:function(){
return this._offsetY;
},set_offsetY:function(_be){
if(this._offsetY!=_be){
this._offsetY=_be;
}
},get_title:function(){
return this._title;
},set_title:function(_bf){
if(this._title!=_bf){
this._title=_bf;
}
this._refreshTitle();
},get_text:function(){
return this._text;
},set_text:function(_c0){
if(this._text!=_c0){
this._text=_c0;
}
if(this.isCreated()){
this.set_content(this._text);
}
},get_width:function(){
return this._width;
},set_width:function(_c1){
if(this._width!=_c1){
this._width=_c1;
}
},get_height:function(){
return this._height;
},set_height:function(_c2){
if(this._height!=_c2){
this._height=_c2;
}
},get_relativeTo:function(){
return this._relativeTo;
},set_relativeTo:function(_c3){
if(this._relativeTo!=_c3){
this._relativeTo=_c3;
}
},get_contentScrolling:function(){
return this._contentScrolling;
},set_contentScrolling:function(_c4){
if(this._contentScrolling!=_c4){
this._contentScrolling=_c4;
}
},get_sticky:function(){
return this._sticky;
},set_sticky:function(_c5){
if(this._sticky!=_c5){
this._sticky=_c5;
}
},get_manualClose:function(){
return this._manualClose;
},set_manualClose:function(_c6){
if(this._manualClose!=_c6){
this._manualClose=_c6;
}
},get_showCallout:function(){
return this._showCallout;
},set_showCallout:function(_c7){
if(this._showCallout!=_c7){
this._showCallout=_c7;
}
},get_showDelay:function(){
return this._showDelay;
},set_showDelay:function(_c8){
if(this._showDelay!=_c8){
this._showDelay=_c8;
}
},get_autoCloseDelay:function(){
return this._autoCloseDelay;
},set_autoCloseDelay:function(_c9){
if(this._autoCloseDelay!=_c9){
this._autoCloseDelay=_c9;
}
},get_hideDelay:function(){
return this._hideDelay;
},set_hideDelay:function(_ca){
if(this._hideDelay!=_ca){
this._hideDelay=_ca;
}
},get_mouseTrailing:function(){
return this._mouseTrailing;
},set_mouseTrailing:function(_cb){
if(this._mouseTrailing!=_cb){
this._mouseTrailing=_cb;
if(true==_cb){
this.set_relativeTo(Telerik.Web.UI.ToolTipRelativeDisplay.Mouse);
}
}
},get_visibleOnPageLoad:function(){
return this._visibleOnPageLoad;
},set_visibleOnPageLoad:function(_cc){
if(this._visibleOnPageLoad!=_cc){
this._visibleOnPageLoad=_cc;
}
},get_animation:function(){
return this._animation;
},set_animation:function(_cd){
if(this._animation!=_cd){
this._animation=_cd;
}
},get_showEvent:function(){
return this._showEvent;
},set_showEvent:function(_ce){
if(this._showEvent!=_ce){
this._showEvent=_ce;
}
},get_skin:function(){
return this._skin;
},set_skin:function(_cf){
if(_cf&&this._skin!=_cf){
this._skin=_cf;
}
},get_popupElement:function(){
return this._popupElement;
},get_modal:function(){
return this._modal;
},set_modal:function(_d0){
if(this._modal!=_d0){
this._modal=_d0;
}
this._makeModal(this._modal);
},add_beforeShow:function(_d1){
this.get_events().addHandler("beforeShow",_d1);
},remove_beforeShow:function(_d2){
this.get_events().removeHandler("beforeShow",_d2);
},add_show:function(_d3){
this.get_events().addHandler("show",_d3);
},remove_show:function(_d4){
this.get_events().removeHandler("show",_d4);
},add_beforeHide:function(_d5){
this.get_events().addHandler("beforeHide",_d5);
},remove_beforeHide:function(_d6){
this.get_events().removeHandler("beforeHide",_d6);
},add_hide:function(_d7){
this.get_events().addHandler("hide",_d7);
},remove_hide:function(_d8){
this.get_events().removeHandler("hide",_d8);
},saveClientState:function(){
var _d9=["text","position"];
var _da={};
for(var i=0;i<_d9.length;i++){
_da[_d9[i]]=this["get_"+_d9[i]]();
}
return Sys.Serialization.JavaScriptSerializer.serialize(_da);
}};
Telerik.Web.UI.RadToolTip.registerClass("Telerik.Web.UI.RadToolTip",Telerik.Web.UI.RadWebControl);
Telerik.Web.UI.ToolTipPosition=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.ToolTipPosition.prototype={TopLeft:11,TopCenter:12,TopRight:13,MiddleLeft:21,Center:22,MiddleRight:23,BottomLeft:31,BottomCenter:32,BottomRight:33};
Telerik.Web.UI.ToolTipPosition.registerEnum("Telerik.Web.UI.ToolTipPosition",false);
Telerik.Web.UI.ToolTipRelativeDisplay=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.ToolTipRelativeDisplay.prototype={Mouse:0,Element:1,BrowserWindow:2};
Telerik.Web.UI.ToolTipRelativeDisplay.registerEnum("Telerik.Web.UI.ToolTipRelativeDisplay",false);
Telerik.Web.UI.ToolTipScrolling=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.ToolTipScrolling.prototype={Auto:0,None:1,X:2,Y:3,Both:4};
Telerik.Web.UI.ToolTipScrolling.registerEnum("Telerik.Web.UI.ToolTipScrolling",false);
Telerik.Web.UI.ToolTipAnimation=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.ToolTipAnimation.prototype={None:0,Resize:1,Fade:2,Slide:4,FlyIn:8};
Telerik.Web.UI.ToolTipAnimation.registerEnum("Telerik.Web.UI.ToolTipAnimation",false);
Telerik.Web.UI.ToolTipShowEvent=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.ToolTipShowEvent.prototype={OnMouseOver:1,OnClick:2,OnRightClick:4,OnFocus:8,FromCode:16};
Telerik.Web.UI.ToolTipShowEvent.registerEnum("Telerik.Web.UI.ToolTipShowEvent",false);

